<template>
    <div>
        <Discount
            :data="textEditor"
        />
        <div class="discount-group edit__set_block">
            <div class="row">
                <div class="col-md-4 form-title">
                    <b>Content</b>
                </div>
                <div class="col-md-8 text-right">
                    <b-select
                        v-model="selectedTagMenu"
                        class="form-control select-tags"
                        @change="addText"
                    >
                        <option
                            v-for="(menu, index) in tags"
                            :key="index"
                            :value="menu.title"
                            :disabled="menu.disabled"
                        >
                            {{ menu.title }}
                        </option>
                    </b-select>
                </div>
            </div>
            <ValidationProvider
                v-slot="validationContext"
                rules="required"
                :vid="textEditor.id.toString()"
                name="Headline"
            >
                <b-form-group class="full-width">
                    <div class="discount-text-subtitle">
                        <b>
                            Headline</b>
                    </div>

                    <b-form-input
                        v-model="textEditor.title"
                        class="form-control full-width"
                        name="title"
                        :state="getValidationState(validationContext)"
                        @click="focus"
                    />
                    <b-form-invalid-feedback>
                        {{ validationContext.errors[0] }}
                    </b-form-invalid-feedback>
                </b-form-group>
            </ValidationProvider>
            <ValidationProvider
                v-slot="validationContext"
                rules="required"
                :vid="textEditor.id.toString()"
                name="Body Text"
            >
                <b-form-group class="full-width">
                    <div class="discount-text-subtitle">
                        <b>Body Text</b>
                    </div>

                    <b-form-input
                        v-model="textEditor.text"
                        type="text"
                        class="form-control full-width"
                        name="text"
                        :maxlength="maxCharacter"
                        :state="getValidationState(validationContext)"
                        @click="focus"
                    />
                    <b-form-invalid-feedback>
                        {{ validationContext.errors[0] }}
                    </b-form-invalid-feedback>
                </b-form-group>
            </ValidationProvider>
        </div>
        <div class="discount-group edit__set_block">
            <div class="form-title">
                <b>Sending Timing</b>
            </div>
            <div class="discount-text-subtitle mt-4">
                Send
            </div>
            <div class="form-group form-inline">
                <b-form-input
                    id="send-time"
                    v-model="textEditor.send_time"
                    name="send_time"
                    data-vv-as="Send Time"
                    type="number"
                    min="1"
                    class="my-input mb-2"
                />
                <div class="select-container mb-2">
                    <b-select
                        v-model="textEditor.send_time_type"
                        class="form-control select-tags"
                    >
                        <option
                            v-for="(menu, index) in selectTagSending"
                            :key="index"
                            :value="menu.value"
                        >
                            {{ menu.title }}
                        </option>
                    </b-select>
                </div>
                <span
                    class="mb-2"
                >{{ textEditor.order === 1 ? 'After abandonment' : 'After previous reminder' }}</span>
            </div>
        </div>
    </div>
</template>

<script>
import Discount from '@/components/edit/Discount.vue'
import { pushTags } from '@/store/constants'
export default {
    name: "PushReminder",
    components: {
        Discount
    },
    props: ['textEditor', 'error'],
    data: () => ({
        selectTypeMenus: [
            {
                title: 'Pre-made'
            },
            {
                title: 'Automatic'
            }
        ],
        selectTagSending: [
            {
                title: 'Minutes',
                value: 'minutes'
            },
            {
                title: 'Hours',
                value: 'hours'
            },
        ],
        selectedTagSending: 'Minutes',
        tags: pushTags,
        selectedTagMenu: 'tags',
        selectedTypeMenu: 'Pre-made',
        focusedInput: 0,
        focusedName: '',
        characterLimit: '',
        maxCharacter: 133,
    }),
    methods: {
        addText() {
            const len = this.textEditor[this.focusedName].length
            const before = this.textEditor[this.focusedName].substr(0, this.focusedInput)
            const after = this.textEditor[this.focusedName].substr(this.focusedInput, len)
            this.textEditor[this.focusedName] = before + this.selectedTagMenu + after
            this.focusedInput += this.selectedTagMenu.length
            this.selectedTagMenu = 'tags'
        },
        focus(e) {
            this.focusedInput = e.target.selectionStart
            this.focusedName = e.target.name
        },
        getValidationState({dirty, validated, valid = null}) {
            return dirty || validated ? valid : null;
        },
    }
}
</script>

<style scoped>

</style>
